#!/usr/bin/env python

#Copyright (c) 2006 SUNY at Stony Brook
#Copyright (c) 2006 Avishay Traeger, Nikolai Joukov, Josef Sipek, and Erez Zadok

import os, sys
import sha

def usage(prg):
	print "Usage:\n\t%s INPUT PREFIX SIZE" % (prg,)
	sys.exit(1)
	
def intify(s):
	try:
		return int(s)
	except ValueError:
		# we got a char
		if s.find("k") != -1:
			return int(s[:s.find("k")])*1024
		if s.find("m") != -1:
			return int(s[:s.find("m")])*1024**2
		raise ValueError
	
def blobify(i, p , s):
	try:
		input = i
		prefix = p
		size = intify(s)
	except IndexError:
		print "Error: Invalid number of arguments"
		usage(sys.argv[0])
	except ValueError:
		print "Error: Invalid types for arguments"
		usage(sys.argv[0])
	
	next = "0" * 40
	
	fin = open(input, "rb")
	
	blobn = 0
	while True:
		# create each blob, with the next "pointer" begin null
		buf = fin.read(size)
		if not buf:
			break
	
		fout = open("%s.%03d" % (prefix, blobn), "wb")
		fout.write("%s\n" % (sha.sha(buf).hexdigest(),))
		fout.write("%s\n" % (next,))
		fout.write("%d\n" % (len(buf),))
		fout.write(buf)
		fout.close()
	
		blobn += 1
	
	fin.close()
	
	# rewrite the pointer in blobs 0..n-1 to the actual value
	for blob in range(0,blobn-1):
		fnext = open("%s.%03d" % (prefix,blob+1), "rwb+")
		next = fnext.read(40)
	
		fin = open("%s.%03d" % (prefix,blob), "rwb+")
		fin.seek(40+1) # skip: 40 char hash on first line + '\n'
		fin.write(next)
		fin.close()
	
		fin = fnext
	
	fin.close()
	
if __name__ == "__main__":
	if not len(sys.argv) == 4:
		print "Error: Invalid number of arguments"
		usage(sys.argv[0])
	
	blobify(sys.argv[1], sys.argv[2], sys.argv[3])

